#ifndef MEMLIST_H
#define MEMLIST_H

enum {
	MEM_BLOCK_SIZE = 600 * 1024, /* 600 kB */
};

typedef enum AssetState_t {
	ASSET_NOT_NEEDED = 0,
	ASSET_LOADED     = 1,
	ASSET_NEEDED     = 2,
	ASSET_END        = 255,
} AssetState;

typedef enum AssetType_t {
	ASSET_SOUND    = 0,
	ASSET_MUSIC    = 1,
	ASSET_FRAME    = 2,
	ASSET_PALETTE  = 3,
	ASSET_BYTECODE = 4,
	ASSET_VIDEO    = 5,
} AssetType;

typedef struct Asset_t {
	AssetState state;
	AssetType  type;
	uchar *    data;
	uchar      rank;
	uchar      bank;
	uvlong     bankoffset;
	ushort     packedlength;
	ushort     length;
} Asset;

uchar *_memPtrStart, *_scriptBakPtr, *_scriptCurPtr, *_vidBakPtr, *_vidCurPtr = nil;

void loadmemlist(char *filename);
void allocmemblock(void);
void freememblock(void);
void printmemptrs(void);

#endif /* MEMLIST_H */
